#!/usr/bin/env bash

# Copyright (c) 2013, Matthew Attaway
# All rights reserved.

# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
#     Redistributions of source code must retain the above copyright notice, this 
#     list of conditions and the following disclaimer.
#
#     Redistributions in binary form must reproduce the above copyright notice, 
#     this list of conditions and the following disclaimer in the documentation 
#     and/or other materials provided with the distribution.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
# IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY 
# OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
# OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

#
# this script takes a submitted changelist as an argument and lets you know how many
# of the total files are branched.
# 

file_count=0
branched_count=0

IFS='
'

for f in $(p4 -F '%depotFile%#%headRev%' fstat -e $1 //... | grep -e '//')
do
    how=$(p4 -ztag -F %how0,0% filelog -m1 "$f")
    file_count=$(expr $file_count + 1)

    if [ "$how" = "branch from" ]
    then
        branched_count=$(expr $branched_count + 1)
    else
    	echo $(p4 -ztag filelog -m1 "$f")
    fi

done

echo "$branched_count of $file_count branched"